﻿Imports System.Drawing.Drawing2D

Public Class clsSliderLabel
    Inherits Label

    Dim mOrientation As Boolean = True
    ' Define the property.
    Public Property VertikalOrientation() As Boolean
        Get
            ' The Get property procedure is called when the value
            ' of a property is retrieved.
            Return mOrientation
        End Get
        Set(ByVal value As Boolean)
            ' The Set property procedure is called when the value 
            ' of a property is modified.  The value to be assigned
            ' is passed in the argument to Set.
            mOrientation = value
            Me.Refresh()
        End Set
    End Property

    Dim bPressed As Boolean = False
    ' Define the property.
    Public Property Pressed() As Boolean
        Get
            ' The Get property procedure is called when the value
            ' of a property is retrieved.
            Return bPressed
        End Get
        Set(ByVal value As Boolean)
            ' The Set property procedure is called when the value 
            ' of a property is modified.  The value to be assigned
            ' is passed in the argument to Set.
            bPressed = value
            Me.Refresh()
        End Set
    End Property

    Private bMouseDown As Boolean = False
    '' Define the property.
    'Public Property Down() As Boolean
    '    Get
    '        ' The Get property procedure is called when the value
    '        ' of a property is retrieved.
    '        Return bDown
    '    End Get
    '    Set(ByVal value As Boolean)
    '        ' The Set property procedure is called when the value 
    '        ' of a property is modified.  The value to be assigned
    '        ' is passed in the argument to Set.
    '        bDown = value
    '        Me.Refresh()
    '    End Set
    'End Property

    Private mGradientColor1 As Color = Color.Khaki
    ' Define the property.
    Public Property GradientColor1() As Color
        Get
            ' The Get property procedure is called when the value
            ' of a property is retrieved.
            Return mGradientColor1
        End Get
        Set(ByVal value As Color)
            ' The Set property procedure is called when the value 
            ' of a property is modified.  The value to be assigned
            ' is passed in the argument to Set.
            mGradientColor1 = value
            Me.Refresh()
        End Set
    End Property

    Private mGradientColor2 As Color = Color.DarkKhaki
    ' Define the property.
    Public Property GradientColor2() As Color
        Get
            ' The Get property procedure is called when the value
            ' of a property is retrieved.
            Return mGradientColor2
        End Get
        Set(ByVal value As Color)
            ' The Set property procedure is called when the value 
            ' of a property is modified.  The value to be assigned
            ' is passed in the argument to Set.
            mGradientColor2 = value
            Me.Refresh()
        End Set
    End Property

    Protected Overrides Sub OnPaintBackground(ByVal pevent As PaintEventArgs)
        MyBase.OnPaintBackground(pevent)
        Call DrawSlider(pevent, bMouseDown, Pressed)
    End Sub

#Region "Slider Zeichnen"
    Public Sub DrawSlider(ByVal e As PaintEventArgs, ByVal bMausDown As Boolean, ByVal bPressed As Boolean)
        Try
            With Me

                Dim recB As New Rectangle(0, 0, .Width, .Height)
                Dim Color1 As Color = .GradientColor1
                Dim Color2 As Color = .GradientColor2

                If VertikalOrientation = True Then
                    Dim brshA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Vertical)
                    e.Graphics.FillRectangle(brshA, recB)

                    ' Create points that define polygon.
                    Dim iWidth As Integer = .Width
                    Dim iHalfWidth As Integer = CInt(.Width / 2)
                    Dim iHeight As Integer = CInt(.Height)
                    ' Create pen. 
                    Dim blackPen As New Pen(Color.Black, 1)

                    If .Dock = DockStyle.Bottom Then
                        If bPressed = False Then

                            Dim point1 As New Point(iHalfWidth, 1)
                            Dim point2 As New Point(iHalfWidth + 9, iHeight - 4)
                            Dim point3 As New Point(iHalfWidth - 9, iHeight - 4)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Create location and size of rectangle. 
                            Dim Rectanglex As Integer = CInt(iHalfWidth - ((iHalfWidth / 4)) + (iHalfWidth / 4) / 2)
                            Dim Rectangley As Integer = 1
                            Dim Rectanglewidth As Integer = CInt(iHalfWidth / 4)
                            Dim Rectangleheight As Integer = iHeight - 2

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        Else 'Else-Zweig von If bPressed = False Then

                            Dim point1 As New Point(iHalfWidth, iHeight - 4)
                            Dim point2 As New Point(iHalfWidth - 9, 1)
                            Dim point3 As New Point(iHalfWidth + 9, 1)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Create location and size of rectangle. 
                            Dim Rectanglex As Integer = CInt(iHalfWidth - ((iHalfWidth / 4)) + (iHalfWidth / 4) / 2)
                            Dim Rectangley As Integer = 1
                            Dim Rectanglewidth As Integer = CInt(iHalfWidth / 4)
                            Dim Rectangleheight As Integer = iHeight - 2

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        End If 'Ende von If bPressed = False Then
                    End If 'Ende von If cLabel.Dock = DockStyle.Bottom Then

                    If .Dock = DockStyle.Top Then
                        If bPressed = False Then

                            Dim point1 As New Point(iHalfWidth, iHeight - 4)
                            Dim point2 As New Point(iHalfWidth - 9, 1)
                            Dim point3 As New Point(iHalfWidth + 9, 1)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Create location and size of rectangle. 
                            Dim Rectanglex As Integer = CInt(iHalfWidth - ((iHalfWidth / 4) + (iHalfWidth / 4) / 2))
                            Dim Rectangley As Integer = 1
                            Dim Rectanglewidth As Integer = CInt(iHalfWidth / 4)
                            Dim Rectangleheight As Integer = iHeight - 2

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        Else 'Else-Zweig von If bPressed = False Then

                            Dim point1 As New Point(iHalfWidth, 1)
                            Dim point2 As New Point(iHalfWidth + 9, iHeight - 4)
                            Dim point3 As New Point(iHalfWidth - 9, iHeight - 4)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Create location and size of rectangle. 
                            Dim Rectanglex As Integer = CInt(iHalfWidth - ((iHalfWidth / 4) + (iHalfWidth / 4) / 2))
                            Dim Rectangley As Integer = 1
                            Dim Rectanglewidth As Integer = CInt(iHalfWidth / 4)
                            Dim Rectangleheight As Integer = iHeight - 2

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Vertical)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        End If 'Ende von If bPressed = False Then
                    End If 'Ende von If cLabel.Dock = DockStyle.Top Then

                Else 'Else-Zweig von  If VertikalOrientation = True Then

                    If .Dock = DockStyle.Left Then

                        Dim brshA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Horizontal)
                        e.Graphics.FillRectangle(brshA, recB)

                        Dim iHalfHeight As Integer = CInt(.Height / 2)
                        Dim iWidth As Integer = CInt(.Width)

                        ' Create location and size of rectangle. 
                        Dim Rectanglex As Integer = 0
                        Dim Rectangley As Integer = CInt(iHalfHeight - (iHalfHeight / 4) + (iHalfHeight / 4) / 2)
                        Dim Rectanglewidth As Integer = iWidth - 3
                        Dim Rectangleheight As Integer = iHalfHeight / 4

                        ' Create pen. 
                        Dim blackPen As New Pen(Color.Black, 1)

                        If bPressed = False Then

                            ' Create points that define polygon. 
                            Dim point1 As New Point(1, CInt(iHalfHeight - 9))
                            Dim point2 As New Point(1, CInt(iHalfHeight + 9))
                            Dim point3 As New Point(iWidth - 4, iHalfHeight)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        Else 'Else-Zweig von If bPressed = False Then

                            ' Create points that define polygon. 
                            Dim point1 As New Point(iWidth - 4, CInt(iHalfHeight - 9))
                            Dim point2 As New Point(iWidth - 4, CInt(iHalfHeight + 9))
                            Dim point3 As New Point(1, iHalfHeight)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        End If 'Ende von If bPressed = False Then
                    End If 'Ende von If cLabel.Dock = DockStyle.Left Then

                    If .Dock = DockStyle.Right Then

                        Dim brshA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Horizontal)
                        e.Graphics.FillRectangle(brshA, recB)

                        Dim iHalfHeight As Integer = CInt(.Height / 2)
                        Dim iWidth As Integer = CInt(.Width)

                        ' Create location and size of rectangle. 
                        Dim Rectanglex As Integer = 0
                        Dim Rectangley As Integer = CInt(iHalfHeight - (iHalfHeight / 4) + (iHalfHeight / 4) / 2)
                        Dim Rectanglewidth As Integer = iWidth - 3
                        Dim Rectangleheight As Integer = iHalfHeight / 4

                        ' Create pen. 
                        Dim blackPen As New Pen(Color.Black, 1)

                        If bPressed = False Then

                            ' Create points that define polygon. 
                            Dim point1 As New Point(iWidth - 4, CInt(iHalfHeight - 9))
                            Dim point2 As New Point(iWidth - 4, CInt(iHalfHeight + 9))
                            Dim point3 As New Point(1, iHalfHeight)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        Else 'Else-Zweig von If bPressed = False Then

                            ' Create points that define polygon. 
                            Dim point1 As New Point(1, CInt(iHalfHeight - 9))
                            Dim point2 As New Point(1, CInt(iHalfHeight + 9))
                            Dim point3 As New Point(iWidth - 4, iHalfHeight)
                            Dim curvePoints As Point() = {point1, point2, point3}

                            ' Draw polygon to screen.
                            e.Graphics.DrawPolygon(blackPen, curvePoints)
                            If bMausDown = False Then
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color1, Color2, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Blue, curvePoints)

                            Else
                                Dim RectangleB As New Rectangle(Rectanglex, Rectangley, Rectanglewidth, Rectangleheight)
                                Dim brashA As New Drawing2D.LinearGradientBrush(recB, Color2, Color1, Drawing2D.LinearGradientMode.Horizontal)

                                e.Graphics.FillRectangle(brashA, RectangleB)
                                e.Graphics.FillPolygon(Brushes.Red, curvePoints)

                            End If

                        End If 'Ende von If bPressed = False Then
                    End If 'Ende von If cLabel.Dock = DockStyle.Right Then

                End If 'Ende von If Orientation = GradientOrientation.Vertikal Then

            End With
        Catch ex As Exception

        End Try
    End Sub
#End Region

    Private Sub clsSliderLabel_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        bMouseDown = True
        Me.Refresh()
    End Sub

    Private Sub clsSliderLabel_MouseUp(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        bMouseDown = False
        Me.Refresh()
    End Sub
End Class
